// #autoload
// #name = weaponZoom
// #version = 1.0
// #date = 1/9/03
// #author = DEbig3
// #warrior =  DEbig3
// #email = debig3@attbi.com
// #web = http://debig3.tribalwar.com
// #description = sets zoom levels for each weapon
// #status = release
// #readme =
// #config = weaponZoomConfig

package weaponZoom {
function clientCmdSetWeaponsHudActive(%slot) {
	parent::clientCmdSetWeaponsHudActive(%slot);
	%weapon = $WeaponNames[%slot];
	if ($weaponZoom[%weapon] $= "") {
		%tr2str = "TR2" @ %weapon;
		if ($weaponZoom[%tr2str] $= "")
			$weaponZoom[%weapon] = $weaponZoomDefault;
	}
	%zoomFov = $pref::player::defaultFov / $weaponZoom[%weapon];
	$pref::player::currentFov = %zoomFov;
	if ($ZoomOn)
		setFov(%zoomFov);
}
};

function weaponZoomSave() {
    export("$weaponZoom*", "prefs/weaponZoomPrefs.cs", false);
}

function weaponZoomStartup()
{
	if(!isfile("pref/weaponZoomPrefs.cs")) {
		weaponZoomSave();
    }
	exec("prefs/weaponZoomPrefs.cs");
}

function weaponZoomConfigPopup::onSelect(%this, %id, %text) {
	%value = weaponZoomConfigInput.getValue();
	$weaponZoom[$weaponZoomLastSelected] = %value;
	$weaponZoomLastSelected = %text;
	weaponZoomConfigInput.setValue($weaponZoom[%text]);
}

function weaponZoomConfig::onWake(%this) {
	$weaponZoomLastSelected = "";
	weaponZoomConfigPopup.clear();
	weaponZoomConfigPopup.add("Default", 0);
	weaponZoomConfigPopup.add("Blaster", 1);
	weaponZoomConfigPopup.add("Plasma", 2);
	weaponZoomConfigPopup.add("Chaingun", 3);
	weaponZoomConfigPopup.add("Disc", 4);
	weaponZoomConfigPopup.add("GrenadeLauncher", 5);
	weaponZoomConfigPopup.add("SniperRifle", 6);
	weaponZoomConfigPopup.add("ELFGun", 7);
	weaponZoomConfigPopup.add("Mortar", 8);
	weaponZoomConfigPopup.add("MissileLauncher", 9);
	weaponZoomConfigPopup.add("ShockLance", 10);
	weaponZoomConfigPopup.add("TargetingLaser", 11);
}

if(!isObject(weaponZoom))
{
    new ScriptObject(weaponZoom)
    {
        class = weaponZoom;
    };
}

$weaponZoomDefault = "5";
$weaponZoomBlaster = "10";
$weaponZoomPlasma = "5";
$weaponZoomChaingun = "2";
$weaponZoomDisc = "5";
$weaponZoomGrenadeLauncher = "5";
$weaponZoomSniperRifle = "5";
$weaponZoomELFGun = "5";
$weaponZoomMortar = "5";
$weaponZoomMissileLauncher = "5";
$weaponZoomShockLance = "5";
$weaponZoomTargetingLaser = "5";

new GuiControl(weaponZoomConfig) {
	profile = "GuiDialogProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 16";
	extent = "400 320";
	minExtent = "400 320";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";
	tabIndex = "0";
	guiSetup = "1";

	new ShellFieldCtrl(weaponZoomConfigPane) {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "16 4";
		extent = "342 120";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellPopupMenu(weaponZoomConfigPopup) {
			profile = "ShellPopupProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "6 5";
			extent = "331 36";
			minExtent = "49 36";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "select weapon";
			longTextBuffer = "1";
			maxLength = "255";
			maxPopupHeight = "500";
			buttonBitmap = "gui/shll_pulldown";
			rolloverBarBitmap = "gui/shll_pulldownbar_rol";
			selectedBarBitmap = "gui/shll_pulldownbar_act";
			noButtonStyle = "0";
		};
		new ShellTextEditCtrl(weaponZoomConfigInput) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "72 45";
			extent = "192 192";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			variable = "$weaponZoomCurrentValue";
			wrap = "0";
		};
		new ShellBitmapButton(weaponZoomConfigSave) {
			profile = "ShellButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "110 80";
			extent = "99 38";
			minExtent = "32 38";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			command = "weaponZoomSave();";
			helpTag = "0";
			text = "save";
			simpleStyle = "0";
		};
	};
};

weaponZoomStartup();

activatePackage(weaponZoom);